if(isFile("Add-Ons/System_ReturnToBlockland/server.cs")) {
   if(!$RTB::RTBR_ServerControl_Hook)
      exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
   RTB_registerPref("Max onChatMessage Distance","onChatMessage","onChatMessageDistance","int 1 100","Event_onChatMessage",10,0,0);
}
else
   $onChatMessageDistance = 10;

registerInputEvent(fxDTSBrick, "onChatMessage", "Self fxDTSBrick\tPlayer Player\tClient GameConnection\tMiniGame MiniGame");
function fxDTSBrick::onChatMessage(%this, %cl) {
   $InputTarget_["Self"] = %this;
   $InputTarget_["Player"] = %cl.player;
   $InputTarget_["Client"] = %cl;

   if($Server::LAN)
      $InputTarget_["MiniGame"] = getMiniGameFromObject(%cl);
   else {
      if(getMiniGameFromObject(%obj) == getMiniGameFromObject(%cl))
         $InputTarget_["MiniGame"] = getMiniGameFromObject(%this);
      else
         $InputTarget_["MiniGame"] = 0;
   }
   %this.processInputEvent("onChatMessage", %cl);
}
package onChatMessage {
   function serverCmdMessageSent(%cl, %msg) {
      Parent::serverCmdMessageSent(%cl, %msg);
      if(isObject(%cl.player)) {
         initContainerRadiusSearch(%cl.player.getPosition(), $onChatMessageDistance / 2, $TypeMasks::fxBrickObjectType);
         while(isObject(%obj = containerSearchNext()))
            %obj.schedule(50, onChatMessage, %cl);
      }
   }
};
activatePackage(onChatMessage);